Renamed compress_vob_file method to encode_vob_file and moved to top of function...
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index b11c77d7b60656e0a42c86d83223ac3e55aea916..1b3fec5840f85005ce9650404c89da00be0eed56 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -49,7 +49,7 @@ typeset dvdpath=""
 typeset aspect=""
 typeset SCALE=""
 typeset CROP=""
-typeset profile="hdtv"
+typeset profile="xvid"
 typeset extension=""
 typeset -i keep_isofile=0
 typeset -i keep_vobfile=0
@@ -108,10 +108,13 @@ function usage() {
     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
-    echo >&2 "                 - hdtv = AVI, Xvid codec, 2 pass encoding (default)"
+    echo >&2 "                 - xvid = AVI, Xvid codec, 2 pass encoding, original aspect, no scaling (default)"
+    echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
+    echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
+    echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
-    echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .hdtv, .ipod, etc)"
+    echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
     echo >&2 "                 The default operation is non-mirror mode where only the main"
@@ -348,6 +351,194 @@ trap cleanup EXIT
 ##############################################################################################
 # processing functions
 ##############################################################################################
+
+# encode the vob file into a compressed file format
+function encode_vob_file {
+  typeset -i found_profile=0
+   
+  # XVID profile
+  if [ "$profile" == "xvid" ]; then
+    found_profile=1
+    final_output_file="$dest/$dvdname.avi"
+    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
+    mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
+    mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
+    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[1]="threads=$mencoder_threads"
+    video_encoder_opts[2]="chroma_opt"
+    video_encoder_opts[3]="vhq=4"
+    video_encoder_opts[4]="bvhq=1"
+    video_encoder_opts[5]="quant_type=mpeg"
+    video_encoder_opts[6]="autoaspect"
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    if [ $audio_2ch -eq 0 ]; then
+      # These options produce good 6 channel audio for linux and windows
+      mencoder_audio_opts="-oac copy"
+      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+      mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+      mencoder_audioch_opts[1]="-af channels=6"
+      mencoder_audioch_opts[2]=""
+    else
+      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      mencoder_audioch_opts[0]=""
+    fi
+  fi
+
+  # MP4 encoding profiles
+  if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
+    found_profile=1
+    final_output_file="$dest/$dvdname.mp4"
+    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
+    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
+
+    # Very High Quality (6fps)
+    if [ "$profile" == "mp4vhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=6"
+      video_encoder_opts[3]="frameref=5"
+      video_encoder_opts[4]="bframes=3"
+      video_encoder_opts[5]="8x8dct"
+      video_encoder_opts[6]="me=umh"
+      video_encoder_opts[7]="b_pyramid"
+      video_encoder_opts[8]="weight_b"
+      video_encoder_opts[9]="partitions=all" 
+    fi
+    # High Quality (13fps)
+    if [ "$profile" == "mp4hq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=5"
+      video_encoder_opts[3]="frameref=2"
+      video_encoder_opts[4]="bframes=3"
+      video_encoder_opts[5]="8x8dct"
+      video_encoder_opts[6]="b_pyramid"
+      video_encoder_opts[7]="weight_b"
+    fi
+    # Fast (17fps)
+    if [ "$profile" == "mp4" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=4"
+      video_encoder_opts[3]="bframes=2"
+      video_encoder_opts[4]="b_pyramid"
+      video_encoder_opts[5]="weight_b"
+    fi
+
+    for OPTS in "${video_encoder_opts[@]}"; do
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    if [ $audio_2ch -eq 0 ]; then
+      # These options produce good 6 channel audio for linux and windows
+      #mencoder_audio_opts="-oac copy"
+      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+      #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+      #mencoder_audioch_opts[1]="-af channels=6"
+      #mencoder_audioch_opts[2]=""
+      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+      mencoder_audioch_opts[0]="-channels 6 -srate 48000"
+    else
+      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+      #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      #mencoder_audioch_opts[0]=""
+      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+      mencoder_audioch_opts[0]="-channels 2 -srate 48000"
+    fi
+
+  fi
+
+  # iphone and ipod MP4 profiles
+  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
+    found_profile=1
+    if [ "$profile" == "iphone" ]; then
+      # SCALE: 480x320
+      # scale width to 480, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=480:-10"
+      # scale the video down however far is necessary to fit in 480x320
+      SCALE=",dsize=480:320:0,scale=-8:-8"
+    else
+      # SCALE: 320x240
+      # scale width to 320, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=320:-10"
+      # scale the video down however far is necessary to fit in 320x240
+      SCALE=",dsize=320:240:0,scale=-8:-8"
+    fi
+    final_output_file="$dest/$dvdname.mp4"
+    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
+    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
+    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
+    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[1]="threads=$mencoder_threads"
+    video_encoder_opts[2]="vbv_maxrate=1500"
+    video_encoder_opts[3]="vbv_bufsize=2000"
+    video_encoder_opts[4]="nocabac"
+    video_encoder_opts[5]="me=umh"
+    video_encoder_opts[6]="subq=6"
+    video_encoder_opts[7]="frameref=6"
+    video_encoder_opts[8]="trellis=1"
+    video_encoder_opts[9]="level_idc=30"
+    video_encoder_opts[10]="global_header"
+    video_encoder_opts[11]="bframes=0"
+    video_encoder_opts[12]="partitions=all"
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+    mencoder_audioch_opts[0]="-channels 2 -srate 48000"
+  fi
+
+  if [ $found_profile -eq 0 ]; then
+    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
+  fi
+
+  # Do not edit this line. $mencoder_video_encoder_opts must be last
+  mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
+  mencoder_retval=0
+
+  for PASS in 1 2 
+  do 
+    # Set some options based on which pass we are in
+    mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
+    [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
+    [ $PASS -eq 1 ] && output_file="/dev/null"
+    [ $PASS -eq 2 ] && output_file="$final_output_file"
+  
+    # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
+    for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
+    do
+      echo -e "   Encoding pass $PASS"
+      echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
+      mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
+      mencoder_retval=$? 
+      grep -q "\[channels\] Invalid" $encodelog
+      if [ $? != 0 ]; then         
+        break;
+      else
+        echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
+      fi
+    done
+      
+    if [ $mencoder_retval != 0 ]; then
+      fatal_and_exit "-E- Unhandled mencoder error"
+    fi
+
+    # Concatenate the encode log to our main log file, greping out unwanted lines
+    cat $encodelog | grep -v "Pos:" >> "$logfile"
+
+  done
+}
+
 function make_dvd_iso_image {
 
   isofile="$1"
@@ -806,127 +997,6 @@ function check_for_mplayer_dumpstream_incompatibility {
   fi
 }
 
-# encode the vob file into a compressed file format
-function compress_vob_file {
-  typeset -i found_profile=0
-   
-  if [ "$profile" == "hdtv" ]; then
-    # DIVX 2 pass encoding
-    found_profile=1
-    final_output_file="$dest/$dvdname.avi"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-    mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
-    mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
-    mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
-    video_encoder_opts[1]="threads=$mencoder_threads"
-    video_encoder_opts[2]="chroma_opt"
-    video_encoder_opts[3]="vhq=4"
-    video_encoder_opts[4]="bvhq=1"
-    video_encoder_opts[5]="quant_type=mpeg"
-    video_encoder_opts[6]="autoaspect"
-    for OPTS in "${video_encoder_opts[@]}"; do 
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    if [ $audio_2ch -eq 0 ]; then
-      # These options produce good 6 channel audio for linux and windows
-      mencoder_audio_opts="-oac copy"
-      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
-      mencoder_audioch_opts[0]="-channels 6 -af channels=6"
-      mencoder_audioch_opts[1]="-af channels=6"
-      mencoder_audioch_opts[2]=""
-    else
-      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
-      mencoder_audioch_opts[0]=""
-    fi
-  fi
-
-  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
-    # MP4 encoding 
-    found_profile=1
-    if [ "$profile" == "iphone" ]; then
-      # SCALE: 480x320
-      # scale width to 480, set height appropriately, but keep a multiple of 16
-      #SCALE=",scale=480:-10"
-      # scale the video down however far is necessary to fit in 480x320
-      SCALE=",dsize=480:320:0,scale=-8:-8"
-    else
-      # SCALE: 320x240
-      # scale width to 320, set height appropriately, but keep a multiple of 16
-      #SCALE=",scale=320:-10"
-      # scale the video down however far is necessary to fit in 320x240
-      SCALE=",dsize=320:240:0,scale=-8:-8"
-    fi
-    final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
-    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
-    video_encoder_opts[1]="threads=$mencoder_threads"
-    video_encoder_opts[2]="vbv_maxrate=1500"
-    video_encoder_opts[3]="vbv_bufsize=2000"
-    video_encoder_opts[4]="nocabac"
-    video_encoder_opts[5]="me=umh"
-    video_encoder_opts[6]="subq=6"
-    video_encoder_opts[7]="frameref=6"
-    video_encoder_opts[8]="trellis=1"
-    video_encoder_opts[9]="level_idc=30"
-    video_encoder_opts[10]="global_header"
-    video_encoder_opts[11]="bframes=0"
-    video_encoder_opts[12]="partitions=all"
-    for OPTS in "${video_encoder_opts[@]}"; do 
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-    mencoder_audioch_opts[0]="-channels 2 -srate 48000"
-  fi
-
-  if [ $found_profile -eq 0 ]; then
-    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
-  fi
-
-  # Do not edit this line. $mencoder_video_encoder_opts must be last
-  mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
-  mencoder_retval=0
-
-  for PASS in 1 2 
-  do 
-    # Set some options based on which pass we are in
-    mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
-    [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
-    [ $PASS -eq 1 ] && output_file="/dev/null"
-    [ $PASS -eq 2 ] && output_file="$final_output_file"
-  
-    # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
-    for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
-    do
-      echo -e "   Encoding pass $PASS"
-      echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
-      mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
-      mencoder_retval=$? 
-      grep -q "\[channels\] Invalid" $encodelog
-      if [ $? != 0 ]; then         
-        break;
-      else
-        echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
-      fi
-    done
-      
-    if [ $mencoder_retval != 0 ]; then
-      fatal_and_exit "-E- Unhandled mencoder error"
-    fi
-
-    # Concatenate the encode log to our main log file, greping out unwanted lines
-    cat $encodelog | grep -v "Pos:" >> "$logfile"
-
-  done
-}
-
 function fill_mythvideo_metadata {
 
   # This function must be passed the filename as an argument
@@ -1108,7 +1178,7 @@ if [ $mirror_mode -eq 0 ]; then
       calculate_bitrate_from_target_size        
      
       # encode the vob file into a compressed file format
-      compress_vob_file
+      encode_vob_file
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";